Global unwrapholder, dock

--***************************
--* modified by chuggnut	*
--***************************


rollout unwrapholder "Unwrap tools" width:130 height:20
	(
	--***************
	--*	util locals	*
	--***************
	local hidestate = false
	local versionno = 1.40
	local icn = 45	
	local uviconsI = (getdir #ui + "/icons/uvtools_24i.bmp")
	local UV = modpanel.getcurrentobject()
	local undoflip = true
	local subobjectstate = 1
	struct dims (width, height, mid, maxUV, minUV)

	--***********************
	--* generic functions	*
	--***********************
	
	function vertonlytools mode =
		(
		aligntools.alignU.enabled = mode
		aligntools.alignv.enabled = mode
		aligntools.alignuv.enabled = mode
		aligntools.straighten.enabled = mode
		
		spacetools.spaceU.enabled = mode
		spacetools.spaceV.enabled = mode
		spacetools.spaceUV.enabled = mode
		)
	
	function getdims sel &uv =
		(
		minUV = [99999,99999,0]
		maxUV = [-99999,-99999,0]
		mid = [0,0,0]
		
		for i in sel do
			(
			p = uv.getvertexposition currenttime i
			
			--check X
			if p.x > maxUV.x then
				(
				maxUV.x = p.x
				)
			else
				(
				if p.x < minUV.x do
					(
					minUV.x = p.x
					)
				)
	
			--check Y
			if p.y > maxUV.y then
				(
				maxUV.y = p.y
				)
			else
				(
				if p.y < minUV.y do
					(
					minUV.y = p.y
					)
				)			
			)
		w = (maxUV.x - minUV.x)
		h = (maxUV.y - minUV.y)
		return (dims width:w height:h mid:([minUV.x + (w * 0.5), minUV.Y + (h * 0.5),0]) maxUV:maxuv minUV:minuv)
		)
	
	function seltovertmode uvmod = 
		(
		case uvmod.gettvsubobjectmode() of
			(
			2: uvmod.edgetovertselect()
			3: uvmod.facetovertselect()
			)
		)
	
	function propertysort p prop = 
		(
		for i = 1 to (p.count - 1) do
			(
			low = prop[i]
			pindex = i
			
			--find lowest in list
			
			for n = i + 1 to p.count do
				(
				if prop[n] < low do
					(
					low = prop[n]
					pindex = n
					)
				)
			
			swap p[i] p[pindex]


			swap prop[i] prop[pindex]
			)
		return p	
		)
	
	function subarray arr start end = 
		(
		a = #()
		acount = 0
		
		for i = start to end do
			(
			if arr[i] == undefined do return undefined
			a[acount += 1] = arr[i]
			)
		return a
		)

	function point3sort &p &indexes mode =
		(


		if mode == #x do
			(
			for i = 1 to p.count - 1 do
				(
				for n = (i + 1) to p.count do
					(
					if p[i].x > p[n].x do
						(
						swap p[i] p[n]
						swap indexes[i] indexes[n]
						)
					)
				)
			)
	
		if mode == #Y do
			(
			for i = 1 to p.count - 1 do
				(
				for n = (i + 1) to p.count do
					(
					if p[i].y > p[n].y do
						(
						swap p[i] p[n]
						swap indexes[i] indexes[n]
						)
					)
				)
			)
	
		if mode == #Z do
			(
			for i = 1 to p.count - 1 do
				(
				for n = (i + 1) to p.count do
					(
					if p[i].z > p[n].z do
						(
						swap p[i] verts[n]
						swap indexes[i] indexes[n]
						)
					)
				)
			)		
		)	

	--*******
	--*	ui	*
	--*******
	
	button showhide "Hide" pos:[2,2] width:35 height:15 tooltip:"Minimize"
	button dodock "<" pos:[89,2] width:15 height:15 tooltip:"Dock Side"
	button dohelp "?" pos:[105,2] width:15 height:15 tooltip:"Help"
	label inf1 "V???" pos:[43,2] width:40 height:15	
	
	subrollout holder width:125 height:300 align:#center
	checkButton sub1 "" pos:[21,350] width:27 height:27 images:#(uviconsI, undefined, icn, 30, 27, 30, 27) checked:true tooltip:"<CTRL> to convert"
	checkButton sub2 "" pos:[51,350] width:27 height:27 images:#(uviconsI, undefined, icn, 31, 28, 31, 28) tooltip:"<CTRL> to convert"
	checkButton sub3 "" pos:[81,350] width:27 height:27 images:#(uviconsI, undefined, icn, 32, 29, 32, 29) tooltip:"<CTRL> to convert"
	checkbox syncelement "Sync to Element" pos:[12,383] width:106 height:14 checked:(UV.getTVElementMode() )
	checkbox softcel "Soft Selection" pos:[22,383] width:106 height:14 checked:(UV.getenablesoftselection() )

	on softcel changed state do
		(
		UV.setenablesoftselection state
		)
	
	on dodock pressed do
		(
		xPKW = uv.GetWindowX()
		yPKW = uv.GetWindowY()
		hPKW = uv.GetWindowH()
		wPKW =  uv.GetWindowW() 		
		
		if (dock == #right) or (dock == undefined) then
			(
			dock = #left
			SetDialogPos unwrapholder [xpkw - 135, ypkw]	
			dodock.text = ">"
			)
		else
			(
			dock = #right
			SetDialogPos unwrapholder [xpkw + wpkw, ypkw]
			dodock.text = "<"
			)
		)
	
	on sub1 changed state do
		(
		if keyboard.controlpressed do
			(
			case subobjectstate of
				(
				2: uv.edgetovertselect()
				3: uv.facetovertselect()
				)
			)
		UV.setTVSubObjectMode 1
		sub2.checked = false			
		sub3.checked = false
		sub1.checked = true
		subobjectstate = 1
		)

	on sub2 changed state do
		(
		if keyboard.controlpressed do
			(
			case subobjectstate of
				(
				1: uv.verttoedgeselect()
				3: uv.facetoedgeselect()
				)
			)
		UV.setTVSubObjectMode 2
		sub1.checked = false			
		sub3.checked = false
		sub2.checked = true
		subobjectstate = 2
		)

	on sub3 changed state do
		(
		if keyboard.controlpressed do
			(
			case subobjectstate of
				(
				1: uv.verttofaceselect()
				2: uv.edgetofaceselect()
				)
			)
		UV.setTVSubObjectMode 3
		sub1.checked = false			
		sub2.checked = false
		sub3.checked = true
		subobjectstate = 3
		)	

	on syncelement changed state do
		(
		UV.setTVElementMode state
		)	
	
	on showhide pressed do
		(
		if hidestate then
			(
			h = uv.GetWindowH()
			unwrapholder.height = (h - 6)
			holder.height = (h - 100)
			
			sub1.pos = [21,(h - 73)]
			sub2.pos = [51,(h - 73)]
			sub3.pos = [81,(h - 73)]
			syncelement.pos = [12,(h - 42)]
			softcel.pos = [12,(h - 22)]

			hidestate = false
			showhide.text = "Hide"
			)
		else
			(
			unwrapholder.height = 20
			hidestate = true
			showhide.text = "Show"
			)
		)
	
	on unwrapholder open do
		(
		try
			(
			subobjectlevel = 1
			)
		catch()
		case (UV.getTVSubObjectMode()) of
			(
			1: (sub1.checked = true; sub2.checked = false; sub3.checked = false; subobjectstate = 1)
			2: (sub1.checked = false; sub2.checked = true; sub3.checked = false; subobjectstate = 2)
			3: (sub1.checked = false; sub2.checked = false; sub3.checked = true; subobjectstate = 3)
			)

		-- setup correct panel size
		h = uv.GetWindowH()
		unwrapholder.height = (h - 6)
		holder.height = (h - 100)
		
		sub1.pos = [21,(h - 73)]
		sub2.pos = [51,(h - 73)]
		sub3.pos = [81,(h - 73)]
		syncelement.pos = [12,(h - 42)]
		softcel.pos = [12,(h - 22)]

		hidestate = false
		showhide.text = "Hide"	
		inf1.text = "V" + versionno as string	
		)

	on dohelp pressed do
		(
		messagebox ("Unwraptools "+ versionno as string +"\nSteve Johnson 2003\n\nwww.chuggnut.com\n\nEmail:mail@chuggnut.com") title:"UnwrapTools"
		)	
	)

rollout aligntools "Align Tools" width:114 height:45
	(
	local uv = unwrapholder.uv
	
	function lineofbestfit p axis =
		(
		function centerpoint arr = 
			(
			mid = [0,0,0]
			for i = 1 to arr.count do
				(
				mid += arr[i]
				)
			return (mid / arr.count)
			)	
		
		-- sort points into length order
		
		l = #()
		case axis of
		(
		#x: for i = 1 to p.count do (l[i] = p[i].x)
		#y: for i = 1 to p.count do (l[i] = p[i].y)
		#z: for i = 1 to p.count do (l[i] = p[i].z)
		)
	
		p = unwrapholder.propertysort p l
		
		-- divide point set into 3, if uneven middle section gets odd number
		
		count = p.count / 3
		over = mod p.count 3
		
		a = unwrapholder.subarray p 1 count
		b = unwrapholder.subarray p (count + 1)(count * 2 + over)
		c = unwrapholder.subarray p (count * 2 + over + 1) (count * 3 + over)
	
		-- find centre of each section (A,B,C)
		
		acent = centerpoint a
		bcent = centerpoint b
		ccent = centerpoint c
		
		-- plot line A,C
		--find length from B to line
		
		dline = (ccent - acent)
		pline = (dot (bcent - acent) dline) / length dline
		ponline = acent + (normalize dline * pline)
		
		--move line 1/3 towards B
		
		d = (bcent - ponline) / 3
		return #(acent + d, ccent + d)
		)	
	
	
	
	button alignU "" pos:[8,11] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 6, 6, 6, 6) toolTip:"Align U"
	button alignv "" pos:[32,11] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 5, 5, 5, 5) toolTip:"Align V"
	button alignuv "" pos:[56,11] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 7, 7, 7, 7) toolTip:"Align UV"
	button straighten "" pos:[80,11] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 23, 23, 23, 23) toolTip:"Straighten"

	on straighten pressed do 
		(
		points = (uv.getselectedvertices()) as array
		
		if points.count < 3 do (messagebox "Need to select 3 or more points" title:"UvTools"; return undefined)
		
		v = #() -- list of verts
		vcount = 0
		av = [0,0,0]
		
		for i in points do
			(
			tvert = (uv.getvertexposition currenttime i)
			append v tvert
			--av += tvert
			vcount += 1
			)
		
		for i = 2 to vcount do
			(
			av += (v[i] - v[1])
			)
		
		av = [abs av.x, abs av.y, abs av.z]
		--choose majour axis of average points to sort by
		case of
			(
			((av.x > av.y) and (av.x > av.z)): (axis = #x)
			((av.y > av.z) and (av.y > av.x)): (axis = #y)
			((av.z > av.x) and (av.z > av.y)): (axis = #z)
			)
		
		bf = lineofbestfit v axis
		
		--project points onto best line
		
		bfline = bf[2] - bf[1]
		nbfline = normalize bfline
		lbfline = length bfline
	
		n = 0
		thehold.begin()
		for i in points do
			(
			d = dot bfline (v[n += 1] - bf[1]) / lbfline
			uv.setvertexposition2 currenttime i (bf[1] + (nbfline * d)) false false
			)
		thehold.accept "Straighten"
		uv.updateview()
		)

	on alignu pressed do
		(
		uvsel = uv.getselectedvertices() as array
		mid = 0.0
		for i in uvsel do
			(
			mid += (uv.getvertexposition currenttime i).x
			)
		mid /= uvsel.count
		
		undo "Align U" on
			(
			uv.forceupdate false
			uv.movex mid
			uv.forceupdate true
			uv.updateview()
			)
		)

	on alignv pressed do
		(
		uvsel = uv.getselectedvertices() as array
		mid = 0.0
		for i in uvsel do
			(
			mid += (uv.getvertexposition currenttime i).y
			)
		mid /= uvsel.count
		
		undo "Align V" on
			(
			uv.forceupdate false
			uv.movey mid
			uv.forceupdate true
			uv.updateview()
			)
		)

	on alignuv pressed do
		(
		uvsel = uv.getselectedvertices() as array
		mid = [0,0,0]
		for i in uvsel do
			(
			mid += (uv.getvertexposition currenttime i)
			)
		mid /= uvsel.count
		
		undo "Align UV" on
			(
			uv.forceupdate false
			uv.movex mid.x
			uv.movey mid.y
			uv.forceupdate true
			uv.updateview()
			)
		)		
	)

rollout spacetools "Space Evenly" width:114 height:45
	(
	local uv = unwrapholder.uv
	button spaceU "" pos:[21,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 24, 24, 24, 24) tooltip:"Space Evenly U"
	button spaceV "" pos:[45,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 25, 25, 25, 25) tooltip:"Space Evenly V"
	button spaceUV "" pos:[69,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 26, 26, 26, 26) tooltip:"Space Evenly UV"

--*******************
--*	spacer stuff	*
--*******************

	on spaceU pressed do
		(
		tverts = #()
		tindex = #()
		count = 0

		for i in (uv.getselectedvertices()) do
			(
			append tverts (uv.getvertexposition currenttime i)
			append tindex i
			count += 1
			)
		
		unwrapholder.point3sort &tverts &tindex #X
		
		width = tverts[count].x - tverts[1].x
		space = width / (count - 1)
		
		num = 0
		thehold.begin()
		for i = 1 to count  do
			(
			uv.setvertexposition2 currenttime tindex[i] [(tverts[1].x + (num * space)), tverts[i].y, tverts[i].z ] false false
			num += 1
			)
		uv.updateview()
		thehold.accept "Space U"
		)

	on spaceV pressed do
		(
		tverts = #()
		tindex = #()
		count = 0

		for i in (uv.getselectedvertices()) do

			(
			append tverts (uv.getvertexposition currenttime i)
			append tindex i
			count += 1
			)
		
		unwrapholder.point3sort &tverts &tindex #Y
		
		width = tverts[count].y - tverts[1].y
		space = width / (count - 1)
		
		num = 0
		thehold.begin()
		for i = 1 to count do
			(
			uv.setvertexposition2 currenttime tindex[i] [tverts[i].x, (tverts[1].y + (num * space)), tverts[i].z ] false false
			num += 1
			)
		uv.updateview()
		thehold.accept "Space V"
		)	

	on spaceUV pressed do
		(
		tverts = #()
		tindex = #()
		count = 0

		for i in (uv.getselectedvertices()) do
			(
			append tverts (uv.getvertexposition currenttime i)
			append tindex i
			count += 1
			)
		
		unwrapholder.point3sort &tverts &tindex #X
		
		width = tverts[count].x - tverts[1].x
		space = width / (count - 1)
		
		num = 0
		thehold.begin()
		for i = 1 to count do
			(
			uv.setvertexposition2 currenttime tindex[i] [(tverts[1].x + (num * space)), tverts[i].y, tverts[i].z ] false false
			tverts[i] = [(tverts[1].x + (num * space)), tverts[i].y, tverts[i].z ]
			num += 1
			)

		unwrapholder.point3sort &tverts &tindex #Y
		
		width = tverts[count].y - tverts[1].y
		space = width / (count - 1)
		
		num = 0
		for i = 1 to count do
			(
			uv.setvertexposition2 currenttime tindex[i] [tverts[i].x, (tverts[1].y + (num * space)), tverts[i].z ] false false
			num += 1
			)			
		uv.updateview()
		thehold.accept "Space UV"
		)
	)

rollout dumptools "Dump" width:114 height:149
	(
	function getuvtris &uvmod UVpoly = 
		(
		uvtrilist = #()
		
		for i in UVpoly do
			(
			if (np = uvmod.numberpointsinface i) > 3 then
				(
				for n = 1 to (np - 2) do
					(
					newuv = [0,0,0]
					newuv.x = uvmod.getvertexindexfromface i 1
					newuv.y = uvmod.getvertexindexfromface i (n + 1)
					newuv.z = uvmod.getvertexindexfromface i (n + 2)
					append uvtrilist newuv				
					)
				)
			else
				(


				newuv = [0,0,0]
				newuv.x = uvmod.getvertexindexfromface i 1
				newuv.y = uvmod.getvertexindexfromface i 2
				newuv.z = uvmod.getvertexindexfromface i 3
				append uvtrilist newuv
				)
			)
		return uvtrilist
		)	

	function tridraw map p1 p2 p3 c1 c2 c3 = 
		(
		--*******************************
		--*	sort points to top,mid,bot	*
		--*******************************
		v = #()
		colours = #()
		v[1] = [(p1.x * (map.width - 1)) as integer, (p1.y * (map.height - 1)) as integer, 0]
		v[2] = [(p2.x * (map.width - 1)) as integer, (p2.y * (map.height - 1)) as integer, 0]
		v[3] = [(p3.x * (map.width - 1)) as integer, (p3.y * (map.height - 1))as integer, 0]
		colours[1] = c1 as point3
		colours[2] = c2 as point3
		colours[3] = c3 as point3
		
		for i = 2 to 3 do
			(
			for n = 1 to 3 do
				(
				if v[i].y < v[n].y do
					(
					swap v[i] v[n]
					swap colours[i] colours[n]
					)
				)
			)
		
		--*******************
		--*	work out slopes	*
		--*******************
		slopeA = (v[1].x - v[2].x) / (v[1].y - v[2].y)
		slopeB = (v[3].x - v[1].x) / (v[3].y - v[1].y)
		slopeC = (v[2].x - v[3].x) / (v[2].y - v[3].y)
		
		--***************************
		--*	work out differences	*
		--***************************
		diffA = (v[2].y - v[1].y)
		diffB = (v[3].y - v[1].y)
		diffC = (v[3].y - v[2].y)
		
		cdiffA = (colours[2] - colours[1]) / diffA
		cdiffB = (colours[3] - colours[1]) / diffB
		cdiffC = (colours[3] - colours[2]) / diffC
		
		span1 = #() -- line a/b
		span2 = #() -- line a/c
		span3 = #() -- line b/c
		cspan1 = #()
		cspan2 = #()
		cspan3 = #()
		--***********************************
		--*	get intersections for line B/A	*
		--***********************************
		xs = v[1].x
		x = v[1].x
		y = v[1].y
			
		for i = 1 to diffA do
			(
			x = xs + (i * slopeA) as integer
			y += 1
			span1[i] = [x,y]
			cspan1[i] = (colours[1] + (i * cdiffA))
			)
	
		--***********************************
		--*	get intersections for line A/C	*
		--***********************************
		xs = v[1].x
		x = v[1].x
		y = v[1].y
	
		for i = 1 to diffB do
			(
			x = xs + (i * slopeB) as integer
			y += 1
			span2[i] = [x,y]
			cspan2[i] = (colours[1] + (i * cdiffB))
			)	
	
		--***********************************
		--*	get intersections for line C/B	*
		--***********************************
		xs = v[2].x
		x = v[2].x
		y = v[2].y
		
		for i = 1 to diffC do
			(
			x = xs + (i * slopeC) as integer
			y += 1
			span3[i] = [x,y]
			cspan3[i] = (colours[2] + (i * cdiffC))
			)
			
		--*******************
		--*	draw triangles	*
		--*******************
		
		draw1 = true
		tv = cross ((v[3] - v[1])) [0,0,1]
		if (dot tv ((v[2] - v[3]))) > 0.0 do draw1 = false
		
		if draw1 then
			(
			--***********************
			--*	draw top triangle	*
			--***********************
			for i = 1 to diffA do
				(
				col = #()
				d = (span2[i].x - span1[i].x + 1) -- how many pixels on span
				cmult = (cspan2[i] - cspan1[i]) / d
				for n = 1 to d do
					(
					col[n] = (cspan1[i] + (n * cmult)) as color
					)
				setpixels map span1[i] col
				)
			
			--***************************
			--*	draw bottom triangle	*
			--***************************
			for i = 1 to diffC do
				(
				col = #()
				d = (span2[i + diffA].x - span3[i].x + 1)
				cmult = (cspan2[i + diffA] - cspan3[i]) / d
				for n = 1 to d do
					(
					col[n] = (cspan3[i] + (n * cmult)) as color
					)
				setpixels map span3[i] col
				)			
			)
		else
			(
			--***********************
			--*	draw top triangle	*
			--***********************		
			for i = 1 to diffA do
				(
				col = #()
				d = (span1[i].x - span2[i].x + 1)
				cmult = (cspan1[i] - cspan2[i]) / d
				for n = 1 to d do
					(
					col[n] = (cspan2[i] + (n * cmult)) as color
					)
				setpixels map span2[i] col
				)
	
			--***************************
			--*	draw bottom triangle	*
			--***************************
			for i = 1 to diffC do
				(
				col = #()
				d = (span3[i].x - span2[i + diffA].x + 1)
				cmult = (cspan3[i] - cspan2[i + diffA]) / d
				for n = 1 to d do
					(
					col[n] = (cspan2[i + diffA] + (n * cmult)) as color
					)
				setpixels map span2[i + diffA] col
				)		
			)
		)

	-- Bresenham line implimentation for MAXScript
	-- by Harry Denholm, Kinetix 1998	
	function BLine bmp x1 y1 x2 y2 c =
		(
			-- stick the colour into an array
			local ary = #(c)
			
			-- assign originals
			local Xb = x1 as integer
			local Yb = y1 as integer
			
			-- build the line deltas
			local dX = x2-x1 as float
			local dY = y2-y1 as float
			
			-- straight horiz 
			if dy == 0.0 do 
			(
				local xsign = if x2 < xb then -1 else 1
				setPixels bmp [xb,yb] ary
				while xb != x2 do
				(
					xb += xsign 
					setPixels bmp [xb,yb] ary
				)
				return true
			)
			-- straight vertical 
			if dx == 0.0 do 
			(	
				local ysign = if y2 < yb then -1 else 1
				setPixels bmp [xb,yb] ary
				while yb != y2 do
				(
					yb += ysign 
					setPixels bmp [xb,yb] ary
				)
				return true
			)
		
			-- no straights, go for bresenham line slide
			
			-- set up the movements
			local xsign = if x2 < xb then -1 else 1
			local ysign = if y2 < yb then -1 else 1
			dx = abs(dx)
			dy = abs(dy)
			setPixels bmp [xb,yb] ary
			
			-- line more vertical than horizontal
			if dx < dy then
			(
				local p = 2 * dx - dy
				local const1 = 2 * dx
				local const2 = 2 * (dx - dy)
				while yb != y2 do
				(
					yb += ysign
					if p < 0 then ( p += const1 )
					else
					(	
						p += const2
						xb += xsign
					)
					setPixels bmp [xb,yb] ary
				)
			)
			
			--	line more horizontal than vertical
			else
			(
				local p = 2 * dy - dx
				local const2 = 2 * (dy - dx)
				local const1 = 2 * dy
				while xb != x2 do
				(
					xb = xb + xsign
					if  p < 0 then ( p += const1 )
					else
					(	p += const2
						yb += ysign
					)
					setPixels bmp [xb,yb] ary
				)
			)
		)		
		
	
	dropDownList bitmappreset "" pos:[11,11] width:92 height:21 items:#("128 X 128", "256 X 256", "512 X 512", "1024 X 1024")
	spinner bmpx "X:" pos:[21,36] width:70 height:16 range:[1,3000,128] type:#integer
	spinner bmpy "Y:" pos:[21,55] width:70 height:16 range:[1,3000,128] type:#integer
	button dodump "Dump Map" pos:[11,114] width:91 height:15
	progressBar pbar "" pos:[12,132] width:90 height:5 color:yellow
	radioButtons dumptype "" pos:[34,76] width:46 height:32 labels:#("Wire", "Solid") columns:1

	on bitmappreset selected val do
		(
		case val of
			(
			1: (bmpx.value = 128; bmpy.value = 128)
			2: (bmpx.value = 256; bmpy.value = 256)
			3: (bmpx.value = 512; bmpy.value = 512)
			4: (bmpx.value = 1024; bmpy.value = 1024)
			)
		) 
	
	on dodump pressed do
		(
		with redraw off
			(
			uv = modpanel.getcurrentobject()
			uv.forceupdate false
			bmp = bitmap bmpx.value bmpy.value
			sel = (uv.getselectedpolygons()) as array
			num = uv.numberpolygons()
			mode = #all
	
			if sel.count != 0 do
				(
				if (querybox "Dump Just selected?" title:"Unwrap") do
					(
					mode = #selected
					num = sel.count
					)
				)
			
			if mode == #all do
				(
				if dumptype.state == 1 then
					(
					for i = 1 to num do
						(
						inface = uv.numberpointsinface i
						startind = uv.getvertexindexfromface i 1
						startvert = uv.getvertexposition currenttime startind
						startvert = [startvert.x * (bmpx.value - 1), (1.0 - startvert.y) * (bmpy.value - 1), 0]
						prevvert = startvert
						prevind = startind
				
						for n = 2 to inface do
							(
							ind = uv.getvertexindexfromface i n
							newvert = uv.getvertexposition currenttime ind
							newvert = [newvert.x * (bmpx.value - 1), (1.0 - newvert.y) * (bmpy.value - 1), 0]
							BLine bmp prevvert.x (prevvert.y ) newvert.x (newvert.y) white
							prevvert = newvert
							prevind = ind
							)
				
						BLine bmp prevvert.x (prevvert.y ) startvert.x (startvert.y) white
						pbar.value = (i as float / num) * 100 
						)
					)
				else
					(
					uvtrilist = getuvtris &uv #{1..num}
					
					for i = 1 to num do
						(
						uv_a = uv.getvertexposition currenttime uvtrilist[i].x
						uv_b = uv.getvertexposition currenttime uvtrilist[i].y
						uv_c = uv.getvertexposition currenttime uvtrilist[i].z
						tridraw bmp [uv_a.x,1.0 - uv_a.y,uv_a.z] [uv_b.x,1.0 - uv_b.y,uv_b.z] [uv_c.x,1.0 - uv_c.y,uv_c.z] (color 255 0 0 1) (color 0 255 0 1) (color 0 0 255 1) 
						pbar.value = (i as float / num) * 100 
						)
					)
				)
	
			if mode == #selected do
				(
				if dumptype.state == 1 then
					(
					for i = 1 to num do
						(
						inface = uv.numberpointsinface sel[i]
						startind = uv.getvertexindexfromface sel[i] 1
						startvert = uv.getvertexposition currenttime startind
						startvert = [startvert.x * (bmpx.value - 1), (1.0 - startvert.y) * (bmpy.value - 1), 0]
						prevvert = startvert
						prevind = startind
				
						for n = 2 to inface do
							(
							ind = uv.getvertexindexfromface sel[i] n
							newvert = uv.getvertexposition currenttime ind
							newvert = [newvert.x * (bmpx.value - 1), (1.0 - newvert.y) * (bmpy.value - 1), 0]
							BLine bmp prevvert.x (prevvert.y) newvert.x (newvert.y) white
							prevvert = newvert
							prevind = ind
							)
				
						BLine bmp prevvert.x (prevvert.y) startvert.x (startvert.y) white
						pbar.value = (i as float / num) * 100 
						)
					)
				else
					(
					uvtrilist = getuvtris &uv sel
					
					ts = timestamp()
					for i = 1 to num do
						(
						uv_a = uv.getvertexposition currenttime uvtrilist[i].x
						uv_b = uv.getvertexposition currenttime uvtrilist[i].y
						uv_c = uv.getvertexposition currenttime uvtrilist[i].z
						tridraw bmp [uv_a.x,1.0 - uv_a.y,uv_a.z] [uv_b.x,1.0 - uv_b.y,uv_b.z] [uv_c.x,1.0 - uv_c.y,uv_c.z] (color 255 0 0 1) (color 0 255 0 1) (color 0 0 255 1) 
						pbar.value = (i as float / num) * 100 
						)
					format "time taken : % seconds\n" ((timestamp() - ts) / 1000.0)
					)
				)	
			)
		pbar.value = 0.0 
		display bmp
		uv.forceupdate false		
		uv.updateview()
		)	
	)	

rollout relaxtools "Relax" width:114 height:122
	(
	spinner relitt "Iterations" pos:[17,12] width:79 height:16 range:[1,100,1] type:#integer
	spinner relstr "Strength" pos:[17,35] width:79 height:16 range:[0,1.0,0.1] type:#float
	checkbox rellockedge "Lock Edges" pos:[15,55] width:83 height:15
	checkbox relmatcharea "Match Area" pos:[15,74] width:83 height:15
	button dorelax "Relax" pos:[11,96] width:91 height:15
	
	on dorelax pressed do
		(
		undo "Realx UV" on
			(
			uv = modpanel.getcurrentobject()
			uv.relax relitt.value relstr.value rellockedge.checked relmatcharea.checked
			)
		)
	)

rollout indextools "Index Rotate" width:114 height:43
	(
	button irotcw "" pos:[9,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 9, 9, 9, 9) toolTip:"index rotate clockwise"
	button indrotccw "" pos:[33,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 8, 8, 8, 8) toolTip:"index rotate counter clockwise"
	button quadmirrorX "" pos:[57,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 21, 21, 21, 21) toolTip:"quad mirror U"
	button quadmirrorY "" pos:[81,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 22, 22, 22, 22) toolTip:"quad mirror V"

	on quadmirrorX pressed do
		(
		uv = modpanel.getcurrentobject()
		with redraw off
			(
			uv.forceupdate false
			if uv.gettvsubobjectmode() == 3 then -- only work on faces
				(
				sel = uv.getselectedfaces()
				for i in sel do
					(
					if uv.numberpointsinface i == 4 do
						(
						p1 = uv.getvertexindexfromface i 1
						p2 = uv.getvertexindexfromface i 2
						p3 = uv.getvertexindexfromface i 3
						p4 = uv.getvertexindexfromface i 4
						
						uv.setfacevertexindex i 1 p2
						uv.setfacevertexindex i 2 p1
						uv.setfacevertexindex i 3 p4

						uv.setfacevertexindex i 4 p3						
						)
					)
				)

			else
				(
				messagebox "This only works in face mode on quad polygons"  title:"UvTools"
				)
			)
		uv.forceupdate true
		uv.updateview()		
		)

	on quadmirrorY pressed do
		(
		uv = modpanel.getcurrentobject()
		with redraw off
			(
			uv.forceupdate false
			if uv.gettvsubobjectmode() == 3 then -- only work on faces
				(
				sel = uv.getselectedfaces()
				for i in sel do
					(
					if uv.numberpointsinface i == 4 do
						(
						p1 = uv.getvertexindexfromface i 1
						p2 = uv.getvertexindexfromface i 2
						p3 = uv.getvertexindexfromface i 3
						p4 = uv.getvertexindexfromface i 4
	
						uv.setfacevertexindex i 1 p4
						uv.setfacevertexindex i 2 p3
						uv.setfacevertexindex i 3 p2
						uv.setfacevertexindex i 4 p1						
						)
					)
				)
			else
				(
				messagebox "This only works in face mode on quad polygons"  title:"UvTools"
				)
			)
		uv.forceupdate true
		uv.updateview()		
		)

	on irotccw pressed do
		(
		uv = modpanel.getcurrentobject()
		
		sel = uv.getselectedpolygons()
		uv.selectpolygonsupdate sel false
		thehold.begin()
		for i in sel do
			(
			inface = uv.numberpointsinface i
			index = #()
	
			for n = 1 to inface do
				(
				append index (uv.getvertexindexfromface i n)
				)

			index = #(index[inface]) + index
			deleteitem index (inface + 1)
			
			for n = 1 to inface do
				(
				uv.setfacevertexindex i n index[n]
				)				
			)
		thehold.accept "Index Rotate CCW"
		uv.selectpolygonsupdate sel true
		uv.forceupdate true
		uv.updateview()
				
		)
	
	on irotcw pressed do
		(
		uv = modpanel.getcurrentobject()
		
		sel = uv.getselectedpolygons()
		uv.selectpolygonsupdate sel false
		
		for i in sel do
			(
			inface = uv.numberpointsinface i
			index = #()
	
			for n = 1 to inface do
				(
				append index (uv.getvertexindexfromface i n)
				)

			append index index[1]
			deleteitem index 1
			
			for n = 1 to inface do
				(
				uv.setfacevertexindex i n index[n]
				)				
			)
		uv.selectpolygonsupdate sel true
		uv.forceupdate true
		uv.updateview()		
		)		
	)

rollout centretools "Centre Point Snap" width:114 height:96
	(
	button csnap1 "" pos:[21,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 12, 12, 12, 12) tootip:"Top Left"
	button csnap2 "" pos:[45,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 13, 13, 13, 13) tootip:"Top Middle"
	button csnap3 "" pos:[69,10] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 14, 14, 14, 14) tootip:"Top Right"
	button csnap4 "" pos:[21,35] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 11, 11, 11, 11) tootip:"Left"
	button csnap5 "" pos:[45,35] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 18, 18, 18, 18) tootip:"Middle"
	button csnap6 "" pos:[69,35] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 15, 15, 15, 15) tootip:"Right"
	button csnap7 "" pos:[21,60] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 10, 10, 10, 10) tootip:"Bottom Left"
	button csnap8 "" pos:[45,60] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 17, 17, 17, 17) tootip:"Bottom Middle"
	button csnap9 "" pos:[69,60] width:24 height:24 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 16, 16, 16, 16) tootip:"Bottom Right"

	on csnap1 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 8		

		)

	on csnap2 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 7		
		)

	on csnap3 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 6		
		)		
	
	on csnap4 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 9		
		)

	on csnap5 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 1		
		)

	on csnap6 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 5		
		)	

	on csnap7 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 2		
		)

	on csnap8 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 3		
		)

	on csnap9 pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.snappivot 4		
		)
	)

rollout transformtools "Transform Tools" width:114 height:318
	(
	struct dims (width, height, mid, maxUV, minUV)
	local uv = unwrapholder.uv
	
	spinner uoffs "U:" pos:[24,10] width:74 height:16 range:[-99,992,0] scale:0.0001
	spinner voffs "V:" pos:[24,29] width:74 height:16 range:[-99,99,0] scale:0.0001
	button dooffs "Offset" pos:[12,51] width:90 height:15
	button doscale "Scale" pos:[12,70] width:90 height:15

	button rot45cw "Button" pos:[16,98] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 38, 38, 38, 38) tooltip:"Rotate -45"
	button rot90cw "Button" pos:[43,98] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 37, 37, 37, 37) tooltip:"Rotate -90"
	button rot180cw "Button" pos:[70,98] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 36, 36, 36, 36) tooltip:"Rotate -180"
	button rot45ccw "Button" pos:[16,130] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 39, 39, 39, 39) tooltip:"Rotate 45"
	button rot90ccw "Button" pos:[43,130] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 40, 40, 40, 40) tooltip:"Rotate 90"
	button rot180ccw "Button" pos:[70,130] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 41, 41, 41, 41) tooltip:"Rotate 180"

	button flipU "Button" pos:[30,162] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 21, 21, 21, 21) tooltip:"Mirror U"
	button flipV "Button" pos:[57,162] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 22, 22, 22, 22) tooltip:"Mirror V"

	button nup "Button" pos:[43,198] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 44, 44, 44, 44) toolTip:"Nudge Up"
	button ndown "Button" pos:[43,227] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 45, 45, 45, 45) toolTip:"Nudge Down"
	button nleft "Button" pos:[14,214] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 43, 43, 43, 43) toolTip:"Nudge Left"
	button nright "Button" pos:[72,214] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 42, 42, 42, 42) toolTip:"Nudge Right"
	radioButtons nudgemode "Nudge Mode:" pos:[5,260] width:121 height:30 labels:#("Units", "Pixels") columns:2
	spinner nudgeamount "Amount:" pos:[14,295] width:95 height:16 type:#float

--***********
--*	nudges	*
--***********

on nudegmode changed state do
	(
	if state == 1 then
		(
		nudegamount.type = #float
		)
	else
		(
		nudegamount.type = #integer
		)
	)

on nup pressed do
	(
	if nudgemode.state == 1 then
		(
		offset = nudgeamount.value
		)
	else
		(
		offset = nudgeamount.value * (1.0 / uv.getrenderheight())
		if offset == 0 do offset = nudgeamount.value * 0.00390625
		)
		
	undo "Nudge Up" on
		(		
		uv.moveselectedvertices [0,offset,0]
		)
	)
	
on ndown pressed do
	(
	if nudgemode.state == 1 then
		(
		offset = nudgeamount.value
		)
	else
		(
		offset = nudgeamount.value * (1.0 / uv.getrenderheight())
		if offset == 0 do offset = nudgeamount.value * 0.00390625
		)
		
	undo "Nudge Down" on
		(		
		uv.moveselectedvertices [0,-offset,0]
		)
	)	

on nleft pressed do
	(
	if nudgemode.state == 1 then
		(
		offset = nudgeamount.value
		)
	else
		(
		offset = nudgeamount.value * (1.0 / uv.getrenderwidth())
		if offset == 0 do offset = nudgeamount.value * 0.00390625
		)
		
	undo "Nudge Left" on
		(
		uv.moveselectedvertices [-offset,0,0]
		)
	)

on nright pressed do
	(
	if nudgemode.state == 1 then
		(
		offset = nudgeamount.value
		)
	else
		(
		offset = nudgeamount.value * (1.0 / uv.getrenderwidth())
		if offset == 0 do offset = nudgeamount.value * 0.00390625
		)

	undo "Nudge Right" on
		(		
		uv.moveselectedvertices [offset,0,0]
		)
	)	

--***********
--*	mirrors	*
--***********

	on flipU pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.mirrorh()
		)

	on flipV pressed do
		(
		uv = modpanel.getcurrentobject()
		uv.mirrorv()
		)

--***************
--*	rotations	*
--***************

	on rot45cw pressed do
		(
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv
		uv.RotateSelectedVerticesCenter -0.785398
		)

	on rot90cw pressed do
		(
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv
		uv.RotateSelectedVerticesCenter -1.5708
		)

	on rot180cw pressed do
		(
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv
		uv.RotateSelectedVerticesCenter -3.14159
		)

	on rot45ccw pressed do
		(
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv
		uv.RotateSelectedVerticesCenter 0.785398
		)

	on rot90ccw pressed do
		(
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv
		uv.RotateSelectedVerticesCenter 1.5708
		)

	on rot180ccw pressed do
		(
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv
		uv.RotateSelectedVerticesCenter 3.14159
		)		
	
	on doscale pressed do
		(
		errorstring = ""
		errormode = false
		
		if uoffs.value == 0.0 do (errormode = true; errorstring += " U Offset ")
		if voffs.value == 0.0 do (errormode = true; errorstring += " V Offset ")
		
		if errormode do
			(
			if not (querybox ("Your " + errorstring + " is set to 0.0\nAre you sure?") title:"Confirm action") do
				(
				return false
				)
			)
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv

		undo "UV Scale" on
			(
			uv.scaleselectedverticescenter uoffs.value 1
			uv.scaleselectedverticescenter voffs.value 2
			)

		uv.updateview()
		)

	on dooffs pressed do
		(
		uv = modpanel.getcurrentobject()

		unwrapholder.seltovertmode uv
		undo "UV Offset" on
			(
			uv.moveselectedvertices [uoffs.value, voffs.value, 0]
			)
		uv.updateview()
		)
	)	

rollout tiletools "Tile Tools" width:114 height:177
	(
	struct dims (width, height, mid, maxUV, minUV)
	
	button seldim "Dimensions" pos:[11,13] width:91 height:15
	button centersel "Centre" pos:[51,34] width:51 height:45
	button maxtile "Max Tiling Range" pos:[11,86] width:91 height:15
	spinner xtile "X" pos:[25,107] width:63 height:16 range:[0.1,100,1]
	spinner ytile "Y" pos:[25,128] width:63 height:16 range:[0.1,100,1]
	radioButtons centertype "" pos:[10,33] width:38 height:48 labels:#("U", "V", "UV") columns:1
	checkbox aspect "Keep Aspect?" pos:[11,150] width:91 height:14

--***************
--*	tile stuff	*
--***************
		
	on centersel pressed do 
		(
		uv = modpanel.getcurrentobject()
		sel = uv.getselectedvertices()
		
		d = unwrapholder.getdims sel &uv

		offset = [0.5,0.5,0] - d.mid
		
		case centertype.state of
			(
			1: offset.y = 0.0
			2: offset.x = 0.0
			)

		for i in sel do
			(
			p = uv.getvertexposition currenttime i
			uv.setvertexposition2 currenttime i (p + offset) false false
			)
		uv.updateview()
		)		
		
	on seldim pressed do 
		(
		uv = modpanel.getcurrentobject()
		sel = uv.getselectedvertices()
		
		d = unwrapholder.getdims sel &uv
	
		Messagebox ("width = " + d.width as string + "\nHeight = " + d.height as string + "\nCentre = " + d.mid as string + "\nMax UV = " + d.maxUV as string + "\nMin UV = " + d.minUV as string) title:"Dimensions"
		)

	on maxtile pressed do 
		(
		uv = modpanel.getcurrentobject()
		sel = uv.getselectedvertices()
		
		d = unwrapholder.getdims sel &uv
		
		-- scale if needed
		scX = 1.0
		scY = 1.0
		offset = d.mid
		
		if d.width > xtile.value do (scX = xtile.value / d.width; offset.x = 0.5)
		if d.height > ytile.value do (scY = ytile.value / d.height; offset.y = 0.5)
		
		if (scX == 1.0) and (scY == 1.0) do return false-- exit if no scale
		
		--fit biggest to keep aspect
		amtX = abs (1.0 - scX)

		amtY = abs (1.0 - scY)
		
		if aspect.checked do	
			(
			if amtX > amtY then
				(
				scY = scX
				)
			else
				(
				if amtY > amtX do scX = scY
				)
			)
		
		for i in sel do
			(
			p = (uv.getvertexposition currenttime i) - d.mid
			uv.setvertexposition2 currenttime i ([p.x * scX ,p.y * scY ,0.0] + offset) false false
			)
		uv.updateview()
		)	
	)

rollout moretools "More Tools" width:114 height:90
	(
	button unusedasdead "Clear Unused" pos:[11,13] width:91 height:15
	progressBar pb2 "" pos:[12,34] width:90 height:5 color:yellow
	button selopenedge "Sel Open Edges" pos:[11,44] width:91 height:15
	button fullmap "0 to 1 Fit" pos:[11,63] width:91 height:15

	on unusedasdead pressed do
		(
		with redraw off
			(
			uv = modpanel.getcurrentobject()
			uv.forceupdate false
			numpoly = uv.numberpolygons()
			numverts = uv.numbervertices()
			
			used = #{}
		
			for i = 1 to numpoly do
				(
				for n = 1 to (uv.numberpointsinface i) do
					(
					used[(uv.getvertexindexfromface i n)] = true
					)
				pb2.value = (i as float / numpoly) * 100
				)
	
			unused = #{1..numverts} - used
			for i in unused do
				(
				uv.markasdead i
				)
		
			pb2.value = 0.0
			uv.forceupdate true
			uv.updateview()
			)
	
		)
		
	on fullmap pressed do
		(
		uv = modpanel.getcurrentobject()
		unwrapholder.seltovertmode uv
		sel = uv.getselectedvertices()
		d = unwrapholder.getdims sel &uv
		
		scw = 1.0 / d.width
		sch = 1.0 / d.height
		
		if (querybox "Keep Aspect?" title:"0 to 1 map") do
			(
			if d.width > d.height then
				(
				sch = scw
				)
			else
				(
				scw = sch
				)
			)

		thehold.begin()
		for i in sel do
			(
			tv = (uv.getvertexposition currenttime i) - d.mid
			uv.setvertexposition2 currenttime i ((tv * [scw,sch,0]) + [0.5,0.5,0.0]) false false
			)
		uv.updateview()
		thehold.accept "0 to 1 Map"
		)
	
	on selopenedge pressed do
		(
		uv = modpanel.getcurrentobject()
		
				
		case uv.gettvsubobjectmode() of
			(
			1: (uv.verttoedgeselect())
			3: (uv.facetoedgeselect())
			)
		
		sel = (uv.getselectededges()) as array
		print sel.count
		
		if sel.count == 0 do
			(
			messagebox "Please make a selection first!" title:"UvTools"
			return false
			)
			
		oldsel = uv.getselectededges()
		uv.openedgeselect()
		newsel = (uv.getselectededges()) - oldsel
		uv.selectedges newsel
		uv.openedgeselect()
		uv.settvsubobjectmode 2
		unwrapholder.sub1.state = false
		unwrapholder.sub2.state = true
		unwrapholder.sub3.state = false
		)
	)

rollout deformtools "Deform Tools" width:114 height:257
	(	
	struct dims (width, height, mid, maxUV, minUV)
	local UVs = #()
	local uv, sel, dim, offset, range
	local activecentre = 5
	
	function setcentre num =
		(
		deformtools.activecentre = num
		bits = #{1..9}
		bits[num] = false
		
		deformtools.cent1.checked = not bits[1]
		deformtools.cent2.checked = not bits[2]
		deformtools.cent3.checked = not bits[3]
		deformtools.cent4.checked = not bits[4]
		deformtools.cent5.checked = not bits[5]
		deformtools.cent6.checked = not bits[6]
		deformtools.cent7.checked = not bits[7]
		deformtools.cent8.checked = not bits[8]
		deformtools.cent9.checked = not bits[9]
		)
	
	function getsetup =
		(
		deformtools.uvs = #()
		deformtools.uv = modpanel.getcurrentobject()
		deformtools.sel = (deformtools.uv.getselectedvertices()) as array
		deformtools.dim = unwrapholder.getdims sel &uv
				
		case deformtools.activecentre of
			(
			1: deformtools.offset = [deformtools.dim.minuv.x, deformtools.dim.maxuv.y, 0]
			2: deformtools.offset = [deformtools.dim.mid.x, deformtools.dim.maxuv.y, 0]
			3: deformtools.offset = [deformtools.dim.maxuv.x, deformtools.dim.maxuv.y, 0]
			4: deformtools.offset = [deformtools.dim.minuv.x, deformtools.dim.mid.y, 0]
			5: deformtools.offset = [deformtools.dim.mid.x, deformtools.dim.mid.y, 0]
			6: deformtools.offset = [deformtools.dim.maxuv.x, deformtools.dim.mid.y, 0]
			7: deformtools.offset = [deformtools.dim.minuv.x, deformtools.dim.minuv.y, 0]
			8: deformtools.offset = [deformtools.dim.mid.x, deformtools.dim.minuv.y, 0]
			9: deformtools.offset = [deformtools.dim.maxuv.x, deformtools.dim.minuv.y, 0]
			)
		
		
		for i in sel do
			(
			append deformtools.uvs ((deformtools.uv.getvertexposition currenttime i) - deformtools.offset)
			)	
		
		deformtools.dim.maxuv -= deformtools.offset
		deformtools.dim.minuv -= deformtools.offset
		deformtools.range = deformtools.dim.maxuv - deformtools.dim.minuv
		)
	
	spinner skewv "Skew V" pos:[14,130] width:92 height:16 range:[-90,90,0] scale:0.01
	spinner skewU "Skew U" pos:[14,110] width:92 height:16 range:[-90,90,0] scale:0.01
	timer updatetimer_skewu interval:30 active:false
	timer updatetimer_skewv interval:30 active:false	
	
	spinner taperv "Taper V" pos:[14,179] width:92 height:16 range:[-90,90,0] scale:0.01
	spinner taperu "Taper U" pos:[14,159] width:92 height:16 range:[-90,90,0] scale:0.01
	timer updatetimer_taperu interval:30 active:false
	timer updatetimer_taperv interval:30 active:false


	spinner bendv "Bend V" pos:[14,231] width:92 height:16 range:[-90,90,0] scale:0.01 enabled:false
	spinner bendu "Bend U" pos:[14,211] width:92 height:16 range:[-90,90,0] scale:0.01 enabled:false
	timer updatetimer_bendu interval:30 active:false
	timer updatetimer_bendv interval:30 active:false

	checkbutton cent1 "" pos:[16,21] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 12, 3, 12, 3)
	checkbutton cent2 "" pos:[43,21] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 13, 4, 13, 4)
	checkbutton cent3 "" pos:[70,21] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 14, 19, 14, 19)

	checkbutton cent4 "" pos:[16,48] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 11, 2, 11, 2)
	checkbutton cent5 "" pos:[43,48] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 18, 35, 18, 35) checked:true
	checkbutton cent6 "" pos:[70,48] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 15, 20, 15, 20)

	checkbutton cent7 "" pos:[16,75] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 10, 1, 10, 1)
	checkbutton cent8 "" pos:[43,75] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 17, 34, 17, 34)
	checkbutton cent9 "" pos:[70,75] width:27 height:27 images:#(unwrapholder.uviconsI, undefined, unwrapholder.icn, 16, 33, 16, 33)
	label lbl1 "Centre Point" pos:[27,5] width:59 height:13

--*******************************************************************
--*	centre points													*
--*******************************************************************

	on cent1 changed arg do
		(
		setcentre 1
		)

	on cent2 changed arg do
		(
		setcentre 2
		)

	on cent3 changed arg do
		(
		setcentre 3
		)

	on cent4 changed arg do
		(
		setcentre 4
		)

	on cent5 changed arg do
		(
		setcentre 5
		)

	on cent6 changed arg do
		(
		setcentre 6
		)


	on cent7 changed arg do
		(
		setcentre 7
		)

	on cent8 changed arg do
		(
		setcentre 8
		)

	on cent9 changed arg do
		(
		setcentre 9
		)

--*******************************************************************
--*	skews															*
--*******************************************************************		

	on skewU buttondown do
		(
		getsetup()
		updatetimer_skewu.active = true
		)
	
	on updatetimer_skewu tick do
		(
		updatetimer_skewu.active = false
		with redraw off
			(
			for i = 1 to sel.count do
				(
				amt = (uvs[i].x / range.x) * skewu.value
				uv.setvertexposition2 currenttime sel[i] ([uvs[i].x, uvs[i].y + amt, uvs[i].z] + offset) false false
				)
			)
		
		uv.updateview()	
		updatetimer_skewu.active = true
		)
	
	on skewu buttonup do
		(
		updatetimer_skewu.active = false
		skewu.value = 0.0
		)

	on skewV buttondown do
		(
		getsetup()
		updatetimer_skewv.active = true
		)
	
	on updatetimer_skewv tick do
		(
		updatetimer_skewv.active = false
		with redraw off
			(
			for i = 1 to sel.count do
				(
				amt = (uvs[i].y / range.y) * skewv.value
				uv.setvertexposition2 currenttime sel[i] ([uvs[i].x + amt, uvs[i].y, uvs[i].z] + offset) false false
				)
			)
		uv.updateview()	
		updatetimer_skewv.active = true
		)
	
	on skewV buttonup do
		(
		updatetimer_skewv.active = false
		skewv.value = 0.0
		)

--*******************************************************************
--*	taper															*
--*******************************************************************		

	on taperU buttondown do
		(
		getsetup()
		updatetimer_taperu.active = true
		)
	
	on updatetimer_taperu tick do
		(
		updatetimer_taperu.active = false
		with redraw off
			(
			for i = 1 to sel.count do
				(
				amt = (uvs[i].x / range.x) * taperu.value
				uv.setvertexposition2 currenttime sel[i] ([uvs[i].x, uvs[i].y * (1.0 + amt), uvs[i].z] + offset) false false
				)
			)
		uv.updateview()	
		updatetimer_taperu.active = true
		)
	
	on taperu buttonup do
		(
		updatetimer_taperu.active = false
		taperu.value = 0.0
		)

	on taperV buttondown do
		(
		getsetup()
		updatetimer_taperv.active = true
		)
	
	on updatetimer_taperv tick do
		(
		updatetimer_taperv.active = false
		with redraw off
			(
			for i = 1 to sel.count do
				(
				amt = (uvs[i].y / range.y) * taperv.value
				uv.setvertexposition2 currenttime sel[i] ([uvs[i].x * (1.0 + amt), uvs[i].y, uvs[i].z] + offset) false false
				)
			)
		
		uv.updateview()	
		updatetimer_taperv.active = true
		)
	
	on taperV buttonup do
		(
		updatetimer_taperv.active = false
		taperv.value = 0.0
		)
	)

rollout optionsroll "Options" width:114 height:421
	(
	local uv = unwrapholder.uv
	checkbox custsize "Use Bitmap Size" pos:[6,3] width:102 height:16 checked:true
	spinner custbitmapwidth "Width:" pos:[13,24] width:96 height:16 enabled:true range:[1,9999,256] type:#integer scale:1 fieldwidth:40
	spinner custbitmapheight "Height:" pos:[13,45] width:96 height:16 enabled:true range:[1,9999,256] type:#integer scale:1 fieldwidth:40
	checkbox tilebitmap "Tile Bitmap?" pos:[4,73] width:105 height:16 checked:true
	spinner numtiles "Tiles:" pos:[13,94] width:96 height:16 range:[1,100,1] type:#integer scale:1 fieldwidth:40
	spinner brightness "Brightness:" pos:[13,115] width:96 height:16 range:[0,100,0.5] fieldwidth:40
	checkbox constupdate "Constant Update" pos:[6,229] width:102 height:16
	checkbox highlightverts "Highlight Selected" pos:[6,247] width:105 height:16
	checkbox hiddenedges "Show Hidden" pos:[6,278] width:102 height:16
	label lbl2 "Verts." pos:[25,263] width:42 height:16
	label lbl3 "Edges." pos:[24,294] width:42 height:16
	spinner weldthreshold "" pos:[26,357] width:63 height:16 range:[0,10,0.01]
	label lbl4 "Weld Threshold:" pos:[16,340] width:83 height:16
	checkbox blendtile "Blend Tile To" pos:[6,135] width:83 height:16
	label lbl5 "Background" pos:[24,151] width:64 height:16
	checkbox centretile "Affect Centre Tile" pos:[6,166] width:102 height:16
	checkbox centrepixel "Centre Pixel Snap" pos:[6,307] width:102 height:16
	spinner gridsize "Grid Size:" pos:[11,376] width:100 height:16 range:[0,1,0.01] scale:0.01
	spinner snapstr "Snap Stregth:" pos:[11,398] width:100 height:16 range:[0,.5,0.5] scale:0.01
	checkbox syncviewport "Synch To " pos:[6,197] width:102 height:16
	label lbl7 "Viewport" pos:[25,213] width:69 height:16
	
	on optionsroll open do
		(
		custsize.checked = not uv.getusebitmapres()
		custbitmapwidth.value = uv.getrenderwidth()
		custbitmapheight.value = uv.getrenderheight()		
		constupdate.checked = uv.getconstantupdate()
		highlightverts.checked = uv.getshowselectedvertices()
		weldthreshold.value = uv.getweldthreshold()
		tilebitmap.checked = uv.gettilemap()
		numtiles.value = uv.gettilemaplimit()
		brightness.value = uv.gettilemapbrightness()
		hiddenedges.checked = uv.getdisplayhiddenedges()
		blendtile.checked = uv.getblendtiletobackground()
		centretile.checked = uv.getbrightnessaffectscentertile()
		centrepixel.checked = uv.getmidpixelsnap()
		gridsize.value = uv.getgridsize()
		snapstr.value = uv.getgridstr()
		syncviewport.checked = uv.getsyncselectionmode()
		
		custbitmapwidth.enabled = not custsize.checked
		custbitmapheight.enabled = not custsize.checked	
		
		numtiles.enabled = tilebitmap.checked			
		)
	
	on blendtile changed val do
		(
		uv.setblendtiletobackground val
		)
	
	on centretile changed val do
		(
		uv.setbrightnessaffectscentertile val
		)
	
	on centrepixel changed val do
		(
		uv.setmidpixelsnap val
		)
	
	on snapstr changed val do
		(
		uv.setgridsize val
		)

	on gridsize changed val do
		(
		uv.setgridstr val
		)
	
	on syncviewport changed val do
		(
		uv.setsyncselectionmode val
		)
	
	on custsize changed state do
		(
		uv.setusebitmapres (not state)
		
		custbitmapwidth.enabled = not state
		custbitmapheight.enabled = not state		
		)
	
	on custbitmapwidth changed val do
		(
		uv.setrenderwidth val
		)

	on custbitmapheight changed val do
		(
		uv.setrenderheight val
		)
	
	on constupdate changed state do
		(
		uv.setconstantupdate state
		)
	
	on highlightverts changed state do
		(
		uv.setshowselectedvertices state
		)	

	on tilebitmap changed state do
		(
		uv.settilemap state
		numtiles.enabled = state
		)

	on weldthreshold changed val do
		(
		uv.setweldthreshold val
		)

	on numtiles changed val do
		(
		uv.settilemaplimit val
		)

	on brightness changed val do
		(
		uv.settilemapbrightness val
		)

	on hiddenedges changed val do
		(
		uv.setdisplayhiddenedges val
		)			
	)	

macroScript OpenUnwrapUI category:"UVW Unwrap" internalcategory: "UVW Unwrap" toolTip:"OpenUnwrapUI" silentErrors:TRUE
	(
	local uv = modpanel.getcurrentobject()
	
	function isdateolderthan file1 file2 = 
		(
		d1 = stringstream (getfilemoddate file1)
		d2 = stringstream (getfilemoddate file2)
		
		numd1 = [0,0,0]
		numd2 = [0,0,0]
		
		numd1.x = (readdelimitedstring d1 "/") as integer
		numd1.y = (readdelimitedstring d1 "/") as integer
		numd1.z = (readdelimitedstring d1 " ") as integer
		
		numd2.x = (readdelimitedstring d2 "/") as integer
		numd2.y = (readdelimitedstring d2 "/") as integer
		numd2.z = (readdelimitedstring d2 " ") as integer	
	
		close d1
		close d2
		
		if numd2.z < numd1.z do (return false)
		if numd2.y < numd1.y do (return false)
		if numd2.x < numd1.x do (return false)
	
		return true
		)

	if (getfiles (getdir #ui + "\\icons\\UVtools_24i.tga")).count == 0 do
		(
		messagebox "You are missing you icon tga file!\nPlace UVtools_24i.tga in you ui\\icons dir." title:"Setup Error"
		return false
		)
	
	xPKW =  uv.GetWindowX()
	yPKW =  uv.GetWindowY()
	hPKW =  uv.GetWindowH()
	wPKW =  uv.GetWindowW()
	
	if (hPKW==0) then
	  	(
		yPKW = -50
		)  
	pPKW = Point2 xPKW (yPKW+hPKW)
	
	--***********************************************  
	--*	create icons that match backcolor if needed	*
	--***********************************************
		
	if (getfiles (getdir #ui + "\\icons\\UVtools_24i.bmp")).count == 0 or (isdateolderthan (getdir #ui + "\\icons\\UVtools_24i.tga") (getdir #ui + "\\icons\\UVtools_24i.bmp")) == false do
		(
		backcol = (colorman.getcolor #background) * 255.0
		bmp = openbitmap (getdir #ui + "\\icons\\UVtools_24i.tga")
		icon = bitmap bmp.width bmp.height
		
		for i = 1 to bmp.height do
			(
			line = getpixels bmp [0,i - 1] bmp.width
		
			for n = 1 to bmp.width do
				(
				line[n] = backcol + ((line[n] - backcol) * (line[n].a * 0.00392157))
				)
		
			setpixels icon [0,i - 1] line
			)
		icon.filename = (getdir #ui + "\\icons\\UVtools_24i.bmp")
		save icon
		close bmp
		close icon
		icon = undefined
		bmp = undefined
		line = undefined
		gc()
		print "New unwrap icons built"
		)
		
	--switch all icons ON!
	for i = 1 to 30 do uv.showicon i true
	uv.savecurrentsettingsasdefault()

	case dock of
		(
		#right: createdialog unwrapholder pos:[xpkw + wpkw, ypkw] style:#(#style_border)
		#left: createdialog unwrapholder pos:[xpkw - 135, ypkw] style:#(#style_border)
		undefined: createdialog unwrapholder pos:[xpkw + wpkw, ypkw] style:#(#style_border)
		)

	addsubrollout unwrapholder.holder aligntools
	addsubrollout unwrapholder.holder spacetools
	addsubrollout unwrapholder.holder transformtools
	addsubrollout unwrapholder.holder deformtools
	addsubrollout unwrapholder.holder dumptools
	addsubrollout unwrapholder.holder relaxtools
	addsubrollout unwrapholder.holder centretools rolledup:true
	addsubrollout unwrapholder.holder tiletools rolledup:true
	addsubrollout unwrapholder.holder indextools rolledup:true
	addsubrollout unwrapholder.holder moretools rolledup:true 
	addsubrollout unwrapholder.holder optionsroll rolledup:true
 
	if (hPKW==0) then
		(
		unwrapholder.height = 0
		)
	)

macroScript MoveUnwrapUI category:"UVW Unwrap" internalcategory: "UVW Unwrap"  toolTip:"MoveUnwrapUI" silentErrors:TRUE
	(
	local uv = modpanel.getcurrentobject()
	
	xPKW = uv.GetWindowX()
	yPKW = uv.GetWindowY()
	hPKW = uv.GetWindowH()
	wPKW =  uv.GetWindowW() 
	
	if (hPKW==0) then  
		(
		yPKW = -50
		)
	
	case dock of
		(
		#right: SetDialogPos unwrapholder [xpkw + wpkw, ypkw]	
		#left: SetDialogPos unwrapholder [xpkw - 135, ypkw]
		undefined: SetDialogPos unwrapholder [xpkw + wpkw, ypkw]
		)
	
	if (hPKW==0) then
		(
		unwrapholder.height = 0
		)
	else
		(
		if unwrapholder.hidestate then
			(
			unwrapholder.height = 20
			)
		else
			(
			unwrapholder.height = hPKW - 6
			unwrapholder.holder.height = hPKW - 100 			
			unwrapholder.sub1.pos = [21,(hPKW - 73)]
			unwrapholder.sub2.pos = [51,(hPKW - 73)]
			unwrapholder.sub3.pos = [81,(hPKW - 73)]
			unwrapholder.syncelement.pos = [12,(hPKW - 42)]
			unwrapholder.softcel.pos = [12,(hPKW - 22)]			
			)
		)
	)

macroScript CloseUnwrapUI category:"UVW Unwrap" internalcategory: "UVW Unwrap" toolTip:"CloseUnwrapUI" silentErrors:TRUE	
	(
	destroydialog unwrapholder
	)
	